/*
Nuxt.js module for vuex-wait

Usage:
    - Install vuex-wait package
    - Add this into your nuxt.config.js file:
    {
        modules: [
            // Simple usage
            'vuex-wait/nuxt'

            // Optionally passing options in module configuration
            ['vuex-wait/nuxt', { useVuex: true }]
        ],

        // Optionally passing options in module top level configuration
        wait: { useVuex: true }
    }
*/

const {resolve} = require('path');

module.exports = function nuxtVueWaitModule(moduleOptions) {
    const options = Object.assign({}, this.options.wait, moduleOptions);
    // Register plugin
    this.addPlugin({
        src: resolve(__dirname, 'vuex-wait.template.js'),
        fileName: 'vuex-wait.js',
        options: options
    })
};

// required by nuxt
module.exports.meta = require('../package.json');
