import { END, PROGRESS, START } from './mutation-types';
import { end, endProgress, isArray, progress, start } from '../utils';

export default {
  [START](state, waiter) {
    if (typeof waiter === 'string') {
      state.waitingFor = start(state.waitingFor, waiter);
    }
    if (isArray(waiter)) {
      waiter.forEach(
        wait => (state.waitingFor = start(state.waitingFor, wait))
      );
    }
  },
  [END](state, waiter) {
    if (typeof waiter === 'string') {
      state.waitingFor = end(state.waitingFor, waiter);
      state.progresses = endProgress(state.progresses, waiter);
    }
    if (isArray(waiter)) {
      for (const wait of waiter) {
        state.waitingFor = end(state.waitingFor, wait);
        state.progresses = endProgress(state.progresses, wait);
      }
    }
  },
  [PROGRESS](state, { waiter, current, total }) {
    state.progresses = progress(state.progresses, waiter, current, total);
  }
};
